<?php

class Rpt_model extends CI_Model {

	public function __construct() {

		// Call the Model constructor
		parent::__construct();
	}

	function get_sales_register($where = array(),$limit=null,$offset=null,$order_by_field=null,$order_by_order=null,$like=null, $or_where=null){
		if(!is_null($offset) and !is_null($limit)){
			$this->db->limit($limit,$offset);
		}
		if($order_by_field != null and $order_by_order != null){
			$this->db->order_by($order_by_field, $order_by_order);
		}

		if($like !=null && is_array($like)) {
			foreach($like as $key=>$value) {
				$this->db->like($key, $value);
			}
		}

		if($or_where) {
			$this->db->or_where($or_where);
		}

		$this->db->select('furniture_invoice.*,company_division.*,new_client_master.*,furniture_quotation.*,users.*');
		$this->db->where($where);
		$this->db->from('furniture_invoice');
		$this->db->join('company_division','company_division.division_id = furniture_invoice.quotation_divisionid','inner');
		$this->db->join('new_client_master','new_client_master.client_id = furniture_invoice.client_id','left');
		$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left');
		$this->db->join('users','users.user_id = furniture_quotation.salesman_id','left');
		$rs = $this->db->get();
		$this->db->last_query();

		if($rs->num_rows() > 0){
			return $rs->result_array();
		} else {
			return false;
		}
	}
	function get_receipt_register($where = array(),$limit=null,$offset=null,$order_by_field=null,$order_by_order=null,$like=null, $or_where=null){
		if(!is_null($offset) and !is_null($limit)){
			$this->db->limit($limit,$offset);
		}
		if($order_by_field != null and $order_by_order != null){
			$this->db->order_by($order_by_field, $order_by_order);
		}

		if($like !=null && is_array($like)) {
			foreach($like as $key=>$value) {
				$this->db->like($key, $value);
			}
		}

		if($or_where) {
			$this->db->or_where($or_where);
		}

		$this->db->select('furniture_receipts.*,company_division.*,new_client_master.*');
		$this->db->where($where);
		$this->db->from('furniture_receipts');
		$this->db->join('company_division','company_division.division_id = furniture_receipts.quotation_divisionid','inner');
		$this->db->join('new_client_master','new_client_master.client_id = furniture_receipts.client_id','left');
		//$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left');
		//$this->db->join('users','users.user_id = furniture_quotation.salesman_id','left');
		$rs = $this->db->get();
		$this->db->last_query();

		if($rs->num_rows() > 0){
			return $rs->result_array();
		} else {
			return false;
		}
	}
	function get_purchase_register($where = array(),$limit=null,$offset=null,$order_by_field=null,$order_by_order=null,$like=null, $or_where=null){
		if(!is_null($offset) and !is_null($limit)){
			$this->db->limit($limit,$offset);
		}
		if($order_by_field != null and $order_by_order != null){
			$this->db->order_by($order_by_field, $order_by_order);
		}

		if($like !=null && is_array($like)) {
			foreach($like as $key=>$value) {
				$this->db->like($key, $value);
			}
		}

		if($or_where) {
			$this->db->or_where($or_where);
		}

		$this->db->select('purchase_h.*,company_division.*,supplier_master.*');
		$this->db->where($where);
		$this->db->from('purchase_h');
		$this->db->join('company_division','company_division.division_id = purchase_h.division_id','inner');
		$this->db->join('supplier_master','supplier_master.supplier_id = purchase_h.supplier_id','left');
		//$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left');
		//$this->db->join('users','users.user_id = furniture_quotation.salesman_id','left');
		$rs = $this->db->get();
		if($rs->num_rows() > 0){
			return $rs->result_array();
		} else {
			return false;
		}
	}
	function get_payment_register($where = array(),$limit=null,$offset=null,$order_by_field=null,$order_by_order=null,$like=null, $or_where=null){
		if(!is_null($offset) and !is_null($limit)){
			$this->db->limit($limit,$offset);
		}
		if($order_by_field != null and $order_by_order != null){
			$this->db->order_by($order_by_field, $order_by_order);
		}

		if($like !=null && is_array($like)) {
			foreach($like as $key=>$value) {
				$this->db->like($key, $value);
			}
		}

		if($or_where) {
			$this->db->or_where($or_where);
		}

		$this->db->select('furniture_payments.*,company_division.*,supplier_master.*');
		$this->db->where($where);
		$this->db->from('furniture_payments');
		$this->db->join('company_division','company_division.division_id = furniture_payments.quotation_divisionid','inner');
		$this->db->join('supplier_master','supplier_master.supplier_id = furniture_payments.client_id','left');
		//$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left');
		//$this->db->join('users','users.user_id = furniture_quotation.salesman_id','left');
		$rs = $this->db->get();
		$this->db->last_query();

		if($rs->num_rows() > 0){
			return $rs->result_array();
		} else {
			return false;
		}
	}
	function get_general_receipt_register($where = array(),$limit=null,$offset=null,$order_by_field=null,$order_by_order=null,$like=null, $or_where=null){
		if(!is_null($offset) and !is_null($limit)){
			$this->db->limit($limit,$offset);
		}
		if($order_by_field != null and $order_by_order != null){
			$this->db->order_by($order_by_field, $order_by_order);
		}

		if($like !=null && is_array($like)) {
			foreach($like as $key=>$value) {
				$this->db->like($key, $value);
			}
		}

		if($or_where) {
			$this->db->or_where($or_where);
		}

		$this->db->select('general_receipts.*,company_division.*');
		$this->db->where($where);
		$this->db->from('general_receipts');
		$this->db->join('company_division','company_division.division_id = general_receipts.division_id','inner');
		//$this->db->join('new_client_master','new_client_master.client_id = general_receipts.client_id','left');
		//$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left');
		//$this->db->join('users','users.user_id = furniture_quotation.salesman_id','left');
		$rs = $this->db->get();
		$this->db->last_query();

		if($rs->num_rows() > 0){
			return $rs->result_array();
		} else {
			return false;
		}
	}
	function get_general_payment_register($where = array(),$limit=null,$offset=null,$order_by_field=null,$order_by_order=null,$like=null, $or_where=null){
		if(!is_null($offset) and !is_null($limit)){
			$this->db->limit($limit,$offset);
		}
		if($order_by_field != null and $order_by_order != null){
			$this->db->order_by($order_by_field, $order_by_order);
		}

		if($like !=null && is_array($like)) {
			foreach($like as $key=>$value) {
				$this->db->like($key, $value);
			}
		}

		if($or_where) {
			$this->db->or_where($or_where);
		}

		$this->db->select('general_payments.*,company_division.*');
		$this->db->where($where);
		$this->db->from('general_payments');
		$this->db->join('company_division','company_division.division_id = general_payments.division_id','inner');
		//$this->db->join('supplier_master','supplier_master.supplier_id = furniture_payments.client_id','left');
		//$this->db->join('furniture_quotation','furniture_quotation.id = furniture_invoice.quotation_id','left');
		//$this->db->join('users','users.user_id = furniture_quotation.salesman_id','left');
		$rs = $this->db->get();
		$this->db->last_query();

		if($rs->num_rows() > 0){
			return $rs->result_array();
		} else {
			return false;
		}
	}
	function financial_year_starting_date(){
		$query = $this->db->query("SELECT * FROM `company_details`");
		return $query->row()->financial_year_starting_date;
	}
}
?>
